// --------------------------------------------------------------------------------
//
// Stats log format
//

//********************************************************************//
//                                                  //
//********************************************************************//
#include "stdafx.h"

#include <afxdisp.h>
#include <fstream.h>

#include "Log.h"

#include "Cabrillo.h"

//
// --------------------------------------------------------------------------------
//
extern BOOL dialog_false;
CString CLogWriter::Substitute(LPCSTR s, LPCSTR src, LPCSTR dst, int* piCnt/* = NULL*/)
{
	CString ss = s;
 CString result;

	if (strcmp(src,dst))
	{

		int Pos = ss.Find(src);
		int len = strlen(src);
		int iCnt = 0;
		while (Pos!=-1)
		{
//			ss=ss.Left(Pos)+dst+ss.Mid(Pos+len);
//			Pos = ss.Find(src,Pos+strlen(dst));

  result += ss.Left(Pos) + dst;
  ss = ss.Mid(Pos+len);
  Pos = ss.Find(src);
  
			iCnt++;
		}
		if (piCnt)
			*piCnt=iCnt;
	}
//	return ss;
	return result + ss;
}

//
// --------------------------------------------------------------------------------
//



//
// --------------------------------------------------------------------------------
//

//********************************************************************//
//                             //
//********************************************************************//
BOOL CLogWriter::Setup(CString sMyCall, COleDateTime* StartTime, COleDateTime* EndTime)
{
	// Setup
	
	m_sMyCall = sMyCall;
	m_StartTime = *StartTime;
	m_EndTime = *EndTime;

	m_sCallFileName = Substitute(sMyCall,"/","_");
	m_sCallFileName = Substitute(m_sCallFileName,"\\","_");
	m_sCallFileName.TrimLeft();
	m_sCallFileName.TrimRight();
	if (m_sCallFileName.IsEmpty())
		m_sCallFileName = "EPCRU";

	CString filename = m_sPath + "Plugins\\EPCRU.ini";
	
	// Read settings

#define MAX_BUF 10000

	char buf[MAX_BUF+1];
	const char* section = "Settings";

	GetPrivateProfileString(section, "Operators", m_sMyCall, buf, MAX_BUF, filename);
	m_sOperators = buf;
	GetPrivateProfileString(section, "Name", "", buf, MAX_BUF, filename);
	m_sFullName = buf;
	GetPrivateProfileString(section, "Address", "", buf, MAX_BUF, filename);
	m_sAddress = buf;
	m_sAddress = Substitute(m_sAddress, "<CR>", "\r");
	m_sAddress = Substitute(m_sAddress, "<LF>", "\n");
	GetPrivateProfileString(section, "Claimed", "", buf, MAX_BUF, filename);
	m_sClaimed = buf;
	GetPrivateProfileString(section, "Band", "", buf, MAX_BUF, filename);
	m_sBand = buf;
	GetPrivateProfileString(section, "Power", "", buf, MAX_BUF, filename);
	m_sPower = buf;
	GetPrivateProfileString(section, "Loc", "", buf, MAX_BUF, filename);
	m_sLoc = buf;
	m_sContest = "RUS-WW-PSK";
	m_sCategory = "SINGLE-OP";
	GetPrivateProfileString(section, "Email", "", buf, MAX_BUF, filename);
	m_sEmail = buf;
	GetPrivateProfileString(section, "Club", "", buf, MAX_BUF, filename);
	m_sClub = buf;
	GetPrivateProfileString(section, "SoapBox", "", buf, MAX_BUF, filename);
	m_sSoapBox = buf;
	m_sSoapBox = Substitute(m_sSoapBox, "<CR>", "\r");
	m_sSoapBox = Substitute(m_sSoapBox, "<LF>", "\n");
//	GetPrivateProfileString(section, "Declaration", m_sDecl, buf, MAX_BUF, filename);
//	m_sDeclaration = buf;

	
//	m_iGroup = GetPrivateProfileInt(section, "Group", 0, filename);
//	m_iBand = GetPrivateProfileInt(section, "Band", 0, filename);


	Cabrillo dlg;

	dlg.m_sCall = sMyCall;
    dlg.m_sOperators = m_sOperators;
	dlg.m_sBand = m_sBand;
	dlg.m_sPower = m_sPower;
	dlg.m_sLoc = m_sLoc;
	dlg.m_sCategory = m_sCategory;
	dlg.m_sName = m_sFullName;
	dlg.m_sAddress = m_sAddress;
	dlg.m_sClaimed = m_sClaimed;
	dlg.m_sContest = m_sContest;
	dlg.m_sEmail = m_sEmail;
	dlg.m_sClub = m_sClub;
	dlg.m_sSoapBox = m_sSoapBox;
//	dlg.m_sDeclaration = m_sDeclaration;
	
	if (dlg.DoModal() != IDOK)
		return FALSE; // cancel
	m_sMyCall = dlg.m_sCall;

	m_sOperators = dlg.m_sOperators;
	m_sBand = dlg.m_sBand;
	m_sCategory = dlg.m_sCategory;
	m_sFullName = dlg.m_sName;
	m_sAddress = dlg.m_sAddress;
	m_sPower = dlg.m_sPower;
	m_sContest = dlg.m_sContest;
	m_sEmail = dlg.m_sEmail;
	m_sClub = dlg.m_sClub;
	m_sLoc = dlg.m_sLoc;
	m_sSoapBox = dlg.m_sSoapBox;
/*
	m_sMyDomain.TrimLeft();
	m_sMyDomain.TrimRight();
	if (m_sMyDomain.GetLength() != 2 || !isalpha(m_sMyDomain[0]) || !isalpha(m_sMyDomain[1]))
	{
		MessageBox(AfxGetMainWnd()->m_hWnd, "Please enter your domain abbreviation (2 letters)", NULL, MB_OK );
		goto dlgagain;
	}
*/
	// Write settings

	m_sAddress = Substitute(m_sAddress, "\r", "<CR>");
	m_sAddress = Substitute(m_sAddress, "\n", "<LF>");
	m_sSoapBox = Substitute(m_sSoapBox, "\r","<CR>");
	m_sSoapBox = Substitute(m_sSoapBox, "\n","<LF>");

	WritePrivateProfileString(section, "Band", m_sBand, filename);
	WritePrivateProfileString(section, "Power", m_sPower, filename);
	WritePrivateProfileString(section, "Operators", m_sOperators, filename);
	WritePrivateProfileString(section, "Name", m_sFullName, filename);
	WritePrivateProfileString(section, "Address", m_sAddress, filename);
	WritePrivateProfileString(section, "Category", m_sCategory, filename);
	WritePrivateProfileString(section, "Contest", m_sContest, filename);
	WritePrivateProfileString(section, "Email", m_sEmail, filename);
	WritePrivateProfileString(section, "Club", m_sClub, filename);
	WritePrivateProfileString(section, "SoapBox", m_sSoapBox, filename);
	WritePrivateProfileString(section, "Loc", m_sLoc, filename);
//	CString s;
//	s.Format("%i", m_iGroup);
//	WritePrivateProfileString(section, "Group", s, filename);

	//s.Format("%i", m_iBand);
//	WritePrivateProfileString(section, "Band", s, filename);

	m_sSoapBox = Substitute(m_sSoapBox, "<CR>", "\r\nSOAPBOX: ");
    m_sSoapBox = Substitute(m_sSoapBox, "<LF>", "");
	m_sAddress = Substitute(m_sAddress, "<CR>", "\r\nADDRESS: ");
	m_sAddress = Substitute(m_sAddress, "<LF>", "");

	// Reset
    m_sQsoStrings.RemoveAll();
//	WritePrivateProfileString("Settings", "Start", "1", filename);

	return TRUE;
}

// --------------------------------------------------------------------------------

//********************************************************************//
//                            //
//********************************************************************//
void CLogWriter::AddQso(
						CString sCall,  int kHz, CString sMode,
						COleDateTime* Time, 
						CString sRstS, CString sNrS, CString sRstR, CString sNrR
				)
{
	CString s;
//QSO:  3512 CW 2008-03-08 2000 UT2UZ         KO  001    UR4LWC        HA  001
	CString sTime = Time->Format("%Y-%m-%d %H%M");
/*har len = strlen(sNrS);
	if(len == 4)
		s.Format("QSO: %5i %2s %s %-13s %-3s %-6s %-13s %-3s %s\r\n",
			kHz, sMode, sTime, m_sMyCall, sRstS, sNrS, sCall, sRstR, sNrR);
	else
		if(len == 3)
		s.Format("QSO: %5i %2s %s %-13s %-3s %-6s %-13s %-3s %s\r\n",
			kHz, sMode, sTime, m_sMyCall, sRstS, sNrS, sCall, sRstR, sNrR);
		 else
			 if(len == 2)*/
				s.Format("QSO: %5i %2s %s %-13s %-3s %-6s %-13s %-3s %s\r\n",
					kHz, sMode, sTime, m_sMyCall, sRstS, sNrS, sCall, sRstR, sNrR);

	m_sQsoStrings.Add(s);
}

// --------------------------------------------------------------------------------
extern int gblScore;
void CLogWriter::WriteSummary()
{

}

// --------------------------------------------------------------------------------


//********************************************************************//
//                  <call>.cbr      //
//********************************************************************//
CString CLogWriter::ProduceLog()
{
 //  	CString filename = m_sPath + "Plugins\\EPCRU.ini";
	ofstream file(m_sPath + m_sCallFileName + ".cbr" , ios::out|ios::binary);
	ifstream inpfile(m_sPath + "cabrillo" + ".ini" , ios::in|ios::binary);

	file << "START-OF-LOG: 3.0\r\n";
	file << "CONTEST: RUS-WW-PSK\r\n";
	file << "CALLSIGN: " << m_sMyCall <<"\r\n";
	file << "CATEGORY-OPERATOR: " << m_sCategory << "\r\n";
	file << "CATEGORY-BAND: " << m_sBand << "\r\n";
	file << "CATEGORY-POWER: " << m_sPower << "\r\n";
	file << "CLAIMED-SCORE: " << gblScore << "\r\n";
	file << "EMAIL: " << m_sEmail << "\r\n";
	file << "LOCATION: " << m_sLoc << "\r\n";
	file << "CLUB: " << m_sClub << "\r\n";
	file << "CREATED-BY: MixW \r\n";
	file << "NAME: " << m_sFullName << "\r\n";
	file << "ADDRESS: " << m_sAddress << "\r\n";
	file << "OPERATORS: " << m_sOperators << "\r\n";
	file << "SOAPBOX: " << m_sSoapBox << "\r\n";
	if (!inpfile.bad())
	{
		char c;
		while (!inpfile.eof())
		{
			if (inpfile.read(&c, 1))
				file << c ;
		}
	
		inpfile.close();
		
	}



	int iLines = m_sQsoStrings.GetSize();

	// Output
	for (int j=0; j<iLines; j++)
	{
		file << m_sQsoStrings[j] ;
	}

	file << "END-OF-LOG:\r\n";

	file.flush();
	file.close();
  // 	WritePrivateProfileString("Settings", "Update", "", filename);
	CString sMessage = "File produced: " + m_sCallFileName + ".cbr";
 //   dialog_false = TRUE;
	return sMessage;
}

// --------------------------------------------------------------------------------
