#include <afxtempl.h>

class CLogEntry
{
public:
	CString m_sCall;
	COleDateTime m_DateTime;

	CString m_sDomRcv;
	int m_iSerialRcv;

	int m_iSerialSnt;

	int m_iTour;
};


typedef CArray <CLogEntry, CLogEntry&> CLogEntryList;

class CLogWriter
{
public:

	BOOL Setup(CString sMyCall, COleDateTime* StartTime, COleDateTime* EndTime);

void CLogWriter::AddQso(
						CString sCall,  int kHz, CString sMode,
						COleDateTime* Time, 
						CString sRstS, CString sNrS, CString sRstR, CString sNrR
				);

	CString ProduceLog();

	CString m_sPath;

protected:

	CLogEntryList m_Log[2];
	int m_iQsos[4], m_iCalls[4], m_iDomains[4];
	
	CString Substitute(LPCSTR s, LPCSTR src, LPCSTR dst, int* piCnt = NULL);

	
	void WriteSummary();

	// Consts

	static const char* m_sDecl;

//	static const char* m_sBands[6];
//	static const char* m_sModes[3];
	static const char* m_sGroups[3];

	// Vars

	CString m_sMyCall, m_sFullName, m_sAddress, m_sClaimed, m_sContest,
		m_sEmail, m_sClub, m_sDeclaration, m_sSoapBox, m_sOperators,m_sCategory,m_sBand,m_sPower,m_sLoc;

	CString m_sMyDomain, m_sMyDomainName;

	CString m_sCallFileName;
	CStringArray m_sQsoStrings;

	int m_iGroup/*, m_iBand*/;



	COleDateTime m_StartTime, m_EndTime;

};