//********************************************************************//
//                                    //
//********************************************************************//
#include "stdafx.h"
#include <afxtempl.h>
#include <Afxdisp.h>
#include <process.h>
#include <fstream.h> 
#include "resource.h"
#include "Log.h"
#include "master.h"
#include "oblast.h"
#include "baud.h"
#include "DXCC.h"
#include "mixw2.h"
#include "Stats0.h"


// --------------------------------------------------------------------------------

FILE *ubn; //  ubn
FILE *cbr; //  cbr 
FILE *err_cbr;

//  
CLogWriter LogWriter;

//    , Obl  DXCC
baud* bDlg = NULL;
oblast *m_pObl = NULL;
DXCC *m_pDXCC= NULL;

//C  MixW 
IMixW2 mixw;
CLSID clsid;
IUnknown *pUnk = NULL;
IDispatch *pDisp = NULL;
HRESULT hr;

//    
CString gblNull;
CString gblCall;
CString gblCountry;
int gblCurrentBandIdx = -1;

char RU=0;
int mast = 0;
int gblScore;
BOOL Band10=FALSE;
BOOL dialog_false = FALSE;

char st_time;




typedef CArray <CInfo, CInfo&> InfoList;

InfoList m_InfoList;

CStringArray m_Bands;



BOOL m_bGeneratingLog = FALSE;
BOOL m_bStatsLog = FALSE;

CString m_sPath;
CString m_sMyCont, m_sMyCountry;
CString myCall;
CString Year ;
CString Year_End;
CString Year_Test;

char rus[6][84];
#define MAX_BUF 10000
char buf[MAX_BUF+1];
CString IniSection = "Settings";
CString IniFilename = "Plugins\\EPCRU.ini";


CStringArray m_CallInfo[6];
CStringArray m_DxccInfo[6];
CStringArray m_RusObl[6];
// --------------------------------------------------------------------------------

void WritePrivateProfileInt(CString Section, CString Key, int iValue, CString IniFilename)
{
	CString s; s.Format("%i", iValue);
	WritePrivateProfileString(Section, Key, s, IniFilename);
}

//********************************************************************//
//                                       //
//********************************************************************//


/***********************************************************************************/
UINT ThreadProc( LPVOID pParam )
{
	if (bDlg)
		return 1;
	bDlg = new baud(); //   
    bDlg->DoModal();
	delete bDlg;
	bDlg = NULL;
	return 0;
}

//********************************************************************//
//                                      //
//********************************************************************//
void HideInfoWindow()
{


	if (!bDlg)
		return;
		if (pDisp)
         pDisp->Release();
	      	CoUninitialize(); //   

	bDlg->SendMessage(WM_CLOSE);
	
		while(bDlg)
		{
			Sleep(20);
				bDlg->PostMessage(WM_CLOSE);
		}
			
}

//********************************************************************//
//                                  //
//********************************************************************//

void ShowInfoWindow()
{

	if (bDlg)
		HideInfoWindow();

	::CreateThread(
		  0,
		  0,
		  (LPTHREAD_START_ROUTINE) ThreadProc,
		  0,
		  0,
		  0
		);
	

}

//********************************************************************//
//                            //
//********************************************************************//
BOOL CheckDomain(const char* s)
{

	static const char* Doms[] = 
	{
		"SP",
        "LO",
        "KL",
        "AR",
        "NO",
        "VO",
        "NV",
        "PS",
        "MU",
        "KA",
        "KO",
		"MA",
        "MO",
        "OR",
        "LP",
        "TV",
        "SM",
        "JA",
		"YR",
		"KS",
        "TL",
        "VR",
        "TB",
        "RA",
        "IV",
        "VL",
        "KU",
        "KG",
        "BR",
        "BO",
		"VG",
        "KR",
        "KM",
        "RO",
        "AO",
        "AD",
		"KC",
        "ST",
        "SO",
        "CN",
        "IN",
        "DA",
        "KB",
		"NN",
		"SA",
		"PE",
		"SR",
		"UL",
		"KI",
		"TA",
		"MR",
		"MD",
		"UD",
		"CU",
		"PM",
		"OB",
		"BA",
		"CB",
		"SV",
		"HM",
		"YN",
		"JN",
		"TN",
		"KN",
		"TO",
		"OM",
		"NS",
		"KE",
		"AL",
		"GA",
		"KK",
		"BU",
		"IR",
		"ZK", 
		"HA",
		"TU",
		"HK",
		"EA",
		"SL",
		"MG",
		"AM",
		"CK",
		"PK",
		"YA",
		"SH",
		"KJ",
		"KT",		
		"AN",
		"FJ",
		"MV",
		NULL
	};

	for (const char** ob=Doms; *ob; ob++)
	{
		if (!strcmp(*ob, s))
			return TRUE;
	}
	return FALSE;
}

//********************************************************************//
//                 DXCC -           //
//********************************************************************//
// --------------------------------------------------------------------------------

BOOL IsRusland( const char* sDxccPrefix )
{
	if(!(strcmp(sDxccPrefix, "UA")))  return 1;
	if(!(strcmp(sDxccPrefix, "UA2"))) return 1;
	if(!(strcmp(sDxccPrefix, "UA9"))) return 1;
	return 0;
	
}

// --------------------------------------------------------------------------------
//                    //
//---------------------------------------------------------------------------------

const char*  CheckOblast(const char* s )
{
 char obl[2]; 
 if ((s[1]&0x30) == 0x30)
 {
  obl[0] = s[1];
  obl[1] = s[2];
 }
 else
 {
  obl[0] = s[2];
  obl[1] = s[3];
 }
 obl[2] = '\0';
 if((!(strcmp(obl, "1A"))) || (!(strcmp(obl, "1B"))) || (!(strcmp(obl, "1F")))) return "SP";
 if((!(strcmp(obl, "1C"))) || (!(strcmp(obl, "1D")))) return "LO";
 if(!(strcmp(obl, "1O"))) return "AR";
 if(!(strcmp(obl, "1Q"))) return "VO";
 if(!(strcmp(obl, "1Z"))) return "MU";
 if(!(strcmp(obl, "1T"))) return "NV";
 if(!(strcmp(obl, "1W"))) return "PS";
 if(!(strcmp(obl, "1N"))) return "KL";
 if(!(strcmp(obl, "1P"))) return "NO";
 if((!(strcmp(obl, "2F"))) || (!(strcmp(obl, "2K")))) return "KA";
 if((!(strcmp(obl, "8X"))) || (!(strcmp(obl, "9X")))) return "KO";
 if((!(strcmp(obl, "2Z"))) || (!(strcmp(obl, "3Z"))) || (!(strcmp(obl, "5Z")))) return "BO";
 if((!(strcmp(obl, "2Y"))) || (!(strcmp(obl, "3Y"))) || (!(strcmp(obl, "5Y")))) return "BR";
 if((!(strcmp(obl, "2V"))) || (!(strcmp(obl, "3V"))) || (!(strcmp(obl, "5V")))) return "VL";
 if((!(strcmp(obl, "2Q"))) || (!(strcmp(obl, "3Q"))) || (!(strcmp(obl, "5Q")))) return "VR";
 if((!(strcmp(obl, "2O"))) || (!(strcmp(obl, "3O"))) || (!(strcmp(obl, "5O")))) return "VR";
 if((!(strcmp(obl, "3K"))) || (!(strcmp(obl, "5K")))) return "VR";
 if((!(strcmp(obl, "2U"))) || (!(strcmp(obl, "3U"))) || (!(strcmp(obl, "5U")))) return "IV";
 if((!(strcmp(obl, "2X"))) || (!(strcmp(obl, "3X"))) || (!(strcmp(obl, "5X")))) return "KG";
 if((!(strcmp(obl, "2N"))) || (!(strcmp(obl, "3N"))) || (!(strcmp(obl, "5N")))) return "KS";
 if((!(strcmp(obl, "2W"))) || (!(strcmp(obl, "3W"))) || (!(strcmp(obl, "5W")))) return "KU";
 if((!(strcmp(obl, "2G"))) || (!(strcmp(obl, "3G"))) || (!(strcmp(obl, "5G")))) return "LP";
 if((!(strcmp(obl, "2A"))) || (!(strcmp(obl, "3A"))) || (!(strcmp(obl, "5A")))) return "MA";
 if((!(strcmp(obl, "2B"))) || (!(strcmp(obl, "3B"))) || (!(strcmp(obl, "5B")))) return "MA";
 if((!(strcmp(obl, "2C"))) || (!(strcmp(obl, "3C"))) || (!(strcmp(obl, "5C")))) return "MA";
 if((!(strcmp(obl, "2D"))) || (!(strcmp(obl, "3D"))) || (!(strcmp(obl, "5D")))) return "MO";
 if((!(strcmp(obl, "2H"))) || (!(strcmp(obl, "3H"))) || (!(strcmp(obl, "5H")))) return "MO";
 if((!(strcmp(obl, "3F"))) || (!(strcmp(obl, "5F")))) return "MO";
 if((!(strcmp(obl, "2E"))) || (!(strcmp(obl, "3E"))) || (!(strcmp(obl, "5E")))) return "OR";
 if((!(strcmp(obl, "2S"))) || (!(strcmp(obl, "3S"))) || (!(strcmp(obl, "5S")))) return "RA";
 if((!(strcmp(obl, "2L"))) || (!(strcmp(obl, "3L"))) || (!(strcmp(obl, "5L")))) return "SM";
 if((!(strcmp(obl, "2R"))) || (!(strcmp(obl, "3R"))) || (!(strcmp(obl, "5R")))) return "TB";
 if((!(strcmp(obl, "2I"))) || (!(strcmp(obl, "3I"))) || (!(strcmp(obl, "5I")))) return "TV";
 if((!(strcmp(obl, "2P"))) || (!(strcmp(obl, "3P"))) || (!(strcmp(obl, "5P")))) return "TL";
 if((!(strcmp(obl, "2M"))) || (!(strcmp(obl, "3M"))) || (!(strcmp(obl, "5M")))) return "JA";
 if((!(strcmp(obl, "6Y"))) || (!(strcmp(obl, "7Y")))) return "AD";
 if((!(strcmp(obl, "6W"))) || (!(strcmp(obl, "7W")))) return "DA";
 if((!(strcmp(obl, "6P"))) || (!(strcmp(obl, "7P"))) || (!(strcmp(obl, "6R"))) || (!(strcmp(obl, "7R")))) return "CN";
 if((!(strcmp(obl, "6A"))) || (!(strcmp(obl, "7A"))) || (!(strcmp(obl, "6B")))) return "KR";
 if((!(strcmp(obl, "7B"))) || (!(strcmp(obl, "6C"))) || (!(strcmp(obl, "7C")))) return "KR";
 if((!(strcmp(obl, "6D"))) || (!(strcmp(obl, "7D")))) return "KR";
 if((!(strcmp(obl, "6Q"))) || (!(strcmp(obl, "7Q")))) return "IN";
 if((!(strcmp(obl, "6X"))) || (!(strcmp(obl, "7X")))) return "KB";
 if((!(strcmp(obl, "6I"))) || (!(strcmp(obl, "7I")))) return "KM";
 if((!(strcmp(obl, "6E"))) || (!(strcmp(obl, "7E")))) return "KC";
 if((!(strcmp(obl, "6J"))) || (!(strcmp(obl, "7J")))) return "SO";
 if((!(strcmp(obl, "6U"))) || (!(strcmp(obl, "7U")))) return "AO";
 if((!(strcmp(obl, "6H"))) || (!(strcmp(obl, "7H"))) || (!(strcmp(obl, "6F")))) return "ST";
 if((!(strcmp(obl, "7F"))) || (!(strcmp(obl, "7G"))) || (!(strcmp(obl, "6G")))) return "ST";
 if((!(strcmp(obl, "6L"))) || (!(strcmp(obl, "7L"))) || (!(strcmp(obl, "6M")))) return "RO";
 if((!(strcmp(obl, "7M"))) || (!(strcmp(obl, "6N"))) || (!(strcmp(obl, "7N")))) return "RO";
 if((!(strcmp(obl, "4A"))) || (!(strcmp(obl, "4B")))) return "VG";
 if((!(strcmp(obl, "2T"))) || (!(strcmp(obl, "3T"))) || (!(strcmp(obl, "5T")))) return "NN";
 if((!(strcmp(obl, "8W"))) || (!(strcmp(obl, "9W")))) return "BA";
 if((!(strcmp(obl, "8S"))) || (!(strcmp(obl, "8T"))) || (!(strcmp(obl, "9S"))) || (!(strcmp(obl, "9T")))) return "OB";
 if(!(strcmp(obl, "4S"))) return "MR";
 if(!(strcmp(obl, "4U"))) return "MD";
 if(!(strcmp(obl, "4F"))) return "PE";
 if((!(strcmp(obl, "4P"))) || (!(strcmp(obl, "4Q"))) || (!(strcmp(obl, "4R")))) return "TA";
 if((!(strcmp(obl, "8F"))) || (!(strcmp(obl, "8G"))) || (!(strcmp(obl, "9F"))) || (!(strcmp(obl, "9G")))) return "PM";
 if(!(strcmp(obl, "4W"))) return "UD";
 if((!(strcmp(obl, "4H"))) || (!(strcmp(obl, "4I")))) return "SR";
 if(!(strcmp(obl, "4Y"))) return "CU";
 if((!(strcmp(obl, "4C"))) || (!(strcmp(obl, "4D")))) return "SA";
 if((!(strcmp(obl, "4L"))) || (!(strcmp(obl, "4M")))) return "UL";
 if(!(strcmp(obl, "4N"))) return "KI";
 if((!(strcmp(obl, "8Q"))) || (!(strcmp(obl, "8R"))) || (!(strcmp(obl, "9Q"))) || (!(strcmp(obl, "9R")))) return "KN";
 if((!(strcmp(obl, "8A"))) || (!(strcmp(obl, "8B"))) || (!(strcmp(obl, "9A"))) || (!(strcmp(obl, "9B")))) return "CB";
 if((!(strcmp(obl, "8C"))) || (!(strcmp(obl, "8D"))) || (!(strcmp(obl, "9C"))) || (!(strcmp(obl, "9D")))) return "SV";
 if((!(strcmp(obl, "8J"))) || (!(strcmp(obl, "9J")))) return "HM";
 if((!(strcmp(obl, "8L"))) || (!(strcmp(obl, "9L")))) return "TN";
 if((!(strcmp(obl, "8K"))) || (!(strcmp(obl, "9K")))) return "JN";
 if((!(strcmp(obl, "8Z"))) || (!(strcmp(obl, "9Z")))) return "GA";
 if((!(strcmp(obl, "8U"))) || (!(strcmp(obl, "9U")))) return "KE";
 if((!(strcmp(obl, "8O"))) || (!(strcmp(obl, "9O")))) return "NS";
 if((!(strcmp(obl, "8Y"))) || (!(strcmp(obl, "9Y")))) return "AL";
 if((!(strcmp(obl, "8M"))) || (!(strcmp(obl, "8N"))) || (!(strcmp(obl, "9M"))) || (!(strcmp(obl, "9N")))) return "OM";
 if((!(strcmp(obl, "8H"))) || (!(strcmp(obl, "8I"))) || (!(strcmp(obl, "9H"))) || (!(strcmp(obl, "9I")))) return "TO";
 if(!(strcmp(obl, "0O"))) return "BU";
 if(!(strcmp(obl, "0Y"))) return "TU";
 if(!(strcmp(obl, "0W"))) return "HA";
 if(!(strcmp(obl, "0U"))) return "ZK";
 if((!(strcmp(obl, "0A"))) || (!(strcmp(obl, "0B"))) || (!(strcmp(obl, "0H")))) return "KK";
 if((!(strcmp(obl, "8V"))) || (!(strcmp(obl, "0V")))) return "AB";
 if((!(strcmp(obl, "0S"))) || (!(strcmp(obl, "0T")))) return "IR";
 if(!(strcmp(obl, "0R"))) return "UO";
 if(!(strcmp(obl, "0Q"))) return "YA";
 if(!(strcmp(obl, "0L"))) return "PK";
 if(!(strcmp(obl, "0C"))) return "HK";
 if(!(strcmp(obl, "0J"))) return "AM";
 if(!(strcmp(obl, "0Z"))) return "KT";
 if(!(strcmp(obl, "0I"))) return "MG";
 if(!(strcmp(obl, "0D"))) return "EA";
 if(!(strcmp(obl, "0X"))) return "KJ";
 if(!(strcmp(obl, "0K"))) return "CK";
 if((!(strcmp(obl, "0F"))) || (!(strcmp(obl, "0E")))) return "SL";
 return FALSE;
}// --------------------------------------------------------------------------------
//
// Setup set
//
//********************************************************************//
//               /           //
//********************************************************************//
_declspec(dllexport) void SetupSet0()
{

//	MessageBox(NULL, "No additional setup for this contest", NULL, MB_OK );
			//Using master file ?

	master dlg;
	GetPrivateProfileString(IniSection, "Master", "", buf, MAX_BUF, IniFilename);
    mast = atoi(buf);
	     	dlg.m_master = mast;
			if (dlg.DoModal()==IDOK)
				{
					mast = dlg.m_master;
					WritePrivateProfileInt(IniSection, "Master", mast, IniFilename);
				}

}

// --------------------------------------------------------------------------------
//
// Reset statistics
//
//********************************************************************//
//              DLL .  .               //
//********************************************************************//
_declspec(dllexport) int ResetStats0 (

		const char* sPath,		
		BOOL bGenerateLog,			

		const char* sMyCall,		
									
		COleDateTime* StartTime,	
		COleDateTime* EndTime,		
									

		const char* sName,			
		const char* sQTH,			
		const char* sInfo,			
		const char* sQslTo,			
		const char* sDom,			
		const char* sCounty,		
		const char* sIota,			
		const char* sWWLoc,			

		const char* sPrefix,		
		const char* sDxccPrefix,		
		int iCq,					
		int iItu,					
		int iTz,					
		double iLat,				
		double iLon,				
		const char* sCountry,		
		const char* sCont,			
		const char* sContinent
		
		)
{	


	// Clear lists
	CString call_ubn,call_cbr;
		CString DatTime;m_sPath = sPath; 
	CInfo NewInfo;
	NewInfo.m_DT = *StartTime;
	Year = NewInfo.m_DT.Format("%d.%m");
	st_time=NewInfo.m_DT.GetHour();
	NewInfo.m_DT = *EndTime;
    DatTime=NewInfo.m_DT.Format();
    Year_End = NewInfo.m_DT.Format("%d.%m.%Y");
	Year_Test = NewInfo.m_DT.Format("%Y");



	m_Bands.RemoveAll();
	m_Bands.Add("160m");
	m_Bands.Add("80m");
	m_Bands.Add("40m");
	m_Bands.Add("20m");
	m_Bands.Add("15m");
	m_Bands.Add("10m");
	
	{
		for (int i = 0; i<6; i++)
		{
			m_CallInfo[i].RemoveAll();
			m_CallInfo[i].Add(m_Bands[i]);
			m_CallInfo[i].Add("-");
			m_CallInfo[i].Add("-");
						m_CallInfo[i].Add("-");
		}
	}

    

    myCall = sMyCall;
	m_InfoList.RemoveAll();
	m_Bands.RemoveAll();
    m_bGeneratingLog = bGenerateLog;
    if (IsRusland(sDxccPrefix)) RU=1;
	if (!(strcmp(sDxccPrefix, "UR"))) RU=1;
	if (!(strcmp(sDxccPrefix, "UN"))) RU=1;
	if (!(strcmp(sDxccPrefix, "EU"))) RU=1;
	m_sMyCont = sCont;
	m_sMyCountry = sDxccPrefix;





	ofstream output_file("err.txt");
			  output_file << "Russian PSK TEST UBN file " << endl;
	output_file.close();



    CString filename = "Plugins\\EPCRU.ini";
	#define MAX_BUF 10000
	const char* section = "Settings";
	char buf[MAX_BUF+1];
	GetPrivateProfileString(section, "Master", "", buf, MAX_BUF, filename);
    mast = atoi(buf);

		if (m_bGeneratingLog)
	{

			m_bStatsLog = LogWriter.Setup(sMyCall,  StartTime, EndTime);
				    WritePrivateProfileString(section, "Start", "1",  filename);

	}
	GetPrivateProfileString(section, "Start", "", buf, MAX_BUF, filename);
    dialog_false = atoi(buf);	
	GetPrivateProfileString(section, "Two", "", buf, MAX_BUF, filename);


	if(!dialog_false) 
	{
		if(!bDlg)
		{
;
			ShowInfoWindow();
		    WritePrivateProfileString(section, "Start", "1",  filename);
		}
	}

    else
	{
				    WritePrivateProfileString(section, "Start", "0",  filename);
	}
	


	
	return TRUE;
}
  

// --------------------------------------------------------------------------------
//
// Add QSO
//
//********************************************************************//
//             QSO                            //
//********************************************************************//
_declspec(dllexport) int AddData0 (
		const char* sMyCall,		
		const char* sCall,			
									
		COleDateTime* StartTime,	
		COleDateTime* EndTime,		
		COleDateTime* QslSent,		
		COleDateTime* QslRcvd,		
									
		unsigned int uiFqRx,		
		unsigned int uiFqTx,		


		const char* sMode,			
		const char* sRstSent,		
		const char* sRstRcvd,		
		const char* sExchgSent,		
		const char* sExchgRcvd,		
		const char* sName,			
		const char* sQTH,			
		const char* sInfo,			
		const char* sQslTo,			
		const char* sDom,			
		const char* sCounty,		
		const char* sIota,			
		const char* sWWLoc,			

		const char* sPrefix,		
		const char* sDxccPrefix,		
		int iCq,					
		int iItu,					
		int iTz,					
		double iLat,				
		double iLon,				
		const char* sCountry,
		const char* sCont,			
		const char* sContinent,

		const char* sBandRx,		
		const char* sBandTx			
		
		)
{
	// Check
//char BufferRx[5]; char col; char BufferTx[5];

CString DatTime;char bef;
CString call_ubn,call_cbr,cab_mod;	CString filename = "Plugins\\EPCRU.ini";

	bef = 0;
	ofstream output_file("err.txt", ios::app);

	
	// Check
	CInfo NewInfo;
	NewInfo.m_DT = *StartTime;
    CString sTime = NewInfo.m_DT.Format("%Y-%m-%d %H%M");
	
		// Check
   if(strcmp(sMode,"BPSK31")) 
   {
    if(strcmp(sMode,"BPSK63")) 
	{
	 if(strcmp(sMode,"BPSK62")) 
	 {
	  if(strcmp(sMode,"BPSK125")) 
      {
		  output_file << "QSO:  ";
		  output_file << uiFqTx/1000 << "  " << sMode << "  " << sTime << "  " << sMyCall << "  " << sRstSent << "  " << sExchgSent ;
		  output_file << "  " << sCall << "  " << sRstRcvd << "  " << sExchgRcvd  << "   NO PSK MODE !!!" << endl ;
			output_file.close();
       	return FALSE;
	  }
	 }
	}
   }

	if( sExchgRcvd[0]==0 || sExchgSent[0]==0 ) // No number
	{
		  output_file << "QSO:  ";
		  output_file << uiFqTx/1000 << "  " << sMode << "  " << sTime << "  " << sMyCall << "  " << sRstSent << "  " << sExchgSent ;
		  output_file << "  " << sCall << "  " << sRstRcvd << "  " << sExchgRcvd  << "   NO RX NUMBER !!!" << endl ;
			output_file.close();

		return FALSE;
	}

    
    int qsos = m_InfoList.GetSize();
    
    // Add band name
	
	int bns = m_Bands.GetSize();
	for (int bn=0; bn<bns; bn++)
	{
		if (m_Bands[bn]==sBandRx)
			break; // found
	}
	if (bn==bns) // add
	{
		m_Bands.Add(sBandRx);
	}

	// Add QSO
//	WritePrivateProfileString("Settings", "Start", "0", filename);      
	NewInfo.m_sCall = sCall;
	NewInfo.m_sBandName = sBandRx;
	NewInfo.m_sModeName = sMode;
	NewInfo.m_sCont = sCont;
	NewInfo.m_sRstR = sRstRcvd;
	NewInfo.m_sRstS = sRstSent;
	NewInfo.m_sExchgR = sExchgRcvd;
	NewInfo.m_sExchgS = sExchgSent;
	NewInfo.m_sDxccCountry = sDxccPrefix;
	NewInfo.m_kHz = uiFqTx/1000;
	NewInfo.m_DT = *StartTime;
	
	if (IsRusland(sDxccPrefix))
	{
		CString sDomain = sExchgRcvd;
		sDomain.MakeUpper();
		sDomain.TrimLeft();
		sDomain.TrimRight();
		if (CheckDomain(sDomain))
			NewInfo.m_sDomain = sDomain;
		else
		{

		  output_file << "QSO:  ";
		  output_file << uiFqTx/1000 << "  " << sMode << "  " << sTime << "  " << sMyCall << "  " << sRstSent << "  " << sExchgSent ;
		  output_file << "  " << sCall << "  " << sRstRcvd << "  " << sExchgRcvd  << "  " <<  sDomain << "  Russland Code Area is not acceptable !!!" << endl ;
			output_file.close();
		  return FALSE;
        }
	}
	
	
	for (int qn=0; qn<qsos; qn++)
	{
		if (m_InfoList[qn]==NewInfo)
     		break; // found
			
	}
	if (qn==qsos) // add
	{
        //m_InfoList[qn].counter;
		m_InfoList.Add(NewInfo);
	}

		
	return TRUE;
}

// --------------------------------------------------------------------------------
//
// Remove QSO
//
//********************************************************************//
//               QSO                          //
//********************************************************************//
_declspec(dllexport) int RemoveData0 (
		const char* sMyCall,		
		const char* sCall,			
									
		COleDateTime* StartTime,	
		COleDateTime* EndTime,		
		COleDateTime* QslSent,		
		COleDateTime* QslRcvd,		
									
		unsigned int uiFqRx,		
		unsigned int uiFqTx,		


		const char* sMode,			
		const char* sRstSent,		
		const char* sRstRcvd,		
		const char* sExchgSent,		
		const char* sExchgRcvd,		
		const char* sName,			
		const char* sQTH,			
		const char* sInfo,			
		const char* sQslTo,			
		const char* sDom,			
		const char* sCounty,		
		const char* sIota,			
		const char* sWWLoc,			

		const char* sPrefix,		
		const char* sDxccPrefix,		
		int iCq,					
		int iItu,					
		int iTz,					
		double iLat,				
		double iLon,				
		const char* sCountry,		
		const char* sCont,			
		const char* sContinent,

		const char* sBandRx,		
		const char* sBandTx			
		
		)
{
	// Check

		CString sDomain;
	    int doma = 0;
		int k = 0;
		int mu_ro =0;
		int l = 0;
	

     
	if( sExchgRcvd[0]==0 || sExchgSent[0]==0 ) // No number
		return FALSE;
	
	// Delete QSO

	CInfo NewInfo;

	NewInfo.m_sCall = sCall;
	NewInfo.m_sBandName = sBandRx;
	NewInfo.m_sCont = sCont;
	NewInfo.m_sDxccCountry = sDxccPrefix;
	NewInfo.m_sModeName = sMode;
	NewInfo.m_DT = *StartTime;


	if (IsRusland(sDxccPrefix))
	{
		CString sDomain = sExchgRcvd;
		sDomain.MakeUpper();
		sDomain.TrimLeft();
		sDomain.TrimRight();
		if (CheckDomain(sDomain))
			NewInfo.m_sDomain = sDomain;
		else
			return FALSE;
	}


	int qsos = m_InfoList.GetSize();
	for (int qn=0; qn<qsos; qn++)
		{
     if (m_InfoList[qn].m_sCall == NewInfo.m_sCall)
			if (m_InfoList[qn].m_sModeName == NewInfo.m_sModeName)
			    if (m_InfoList[qn].m_sBandName == NewInfo.m_sBandName)

				{
					  //   
				   if((!(strcmp(NewInfo.m_sDxccCountry,"UA")))   || (!(strcmp(NewInfo.m_sDxccCountry,"UA2"))) || (!(strcmp(NewInfo.m_sDxccCountry,"UA9"))))
				   {	    
					    if(!(strcmp(NewInfo.m_sBandName,"160m")))k=0;
						if(!(strcmp(NewInfo.m_sBandName,"80m"))) k=1;	
						if(!(strcmp(NewInfo.m_sBandName,"40m"))) k=2;
						if(!(strcmp(NewInfo.m_sBandName,"20m"))) k=3;
						if(!(strcmp(NewInfo.m_sBandName,"15m"))) k=4;
						if(!(strcmp(NewInfo.m_sBandName,"10m"))) k=5; 

                        mu_ro = m_RusObl[k].GetSize();
						for(l=0;l<mu_ro ;l++)
						{
							if(m_RusObl[k].ElementAt(l) == sDomain)
								break;
						}
                        	if (mu_ro != l)
					 
											m_RusObl[k].RemoveAt(l); //   ,   
				   }

		        	m_InfoList.RemoveAt(qn);
				   	qsos--;
		           m_InfoList.SetSize(qsos);

		    	  break; // found
				}
		else;
			else;
				else;
	}

	return TRUE; 
}

// --------------------------------------------------------------------------------
//
// Get the result
//

CString result;
//********************************************************************//
//           ,      //
//                                      //
//********************************************************************//
_declspec(dllexport) const char* GetResult0(int* iScore)
{
	CString filename = "Plugins\\EPCRU.ini"; 


	result.Empty();
	int qsos = m_InfoList.GetSize();

	// Header

	CString hdr;
	hdr.Format( 
		"\t\tRUSSIAN PSK WW %s-%s\r\n\t\t\tContestant: %s \r\n\tQSOs\tPoints\tDXCC\tObl\tBPSK31\tBPSK63\tBPSK125\r\n"
		,Year,Year_End,myCall);
	result += hdr;
	
	int bns = m_Bands.GetSize();

	// Sort bands

	for (int i=0; i<bns-1;i++)
	{
		for (int j=i+1; j<bns;j++)
		{
			CString si = m_Bands[i], 
					sj = m_Bands[j]; 

			while( si.GetLength()<20 )
				si = "0"+si;

			while( sj.GetLength()<20 )
				sj = "0"+sj;

			if (si < sj) // swap
			{
				CString tmp = m_Bands[i];
				m_Bands[i] = m_Bands[j];
				m_Bands[j] = tmp;
			}
		}		
	}


	// Calculate and print



	int iMyCountriesTotal=0, iMyContsTotal=0, iDxsTotal=0, iDxccsTotal=0, iDomsTotal=0, iContsTotal=0,
		iPointsTotal=0 , iQSO_PS_Total = 0, iQSO_PM_Total =0 , iQSO_PO_Total = 0 ;

	//CStringArray ContArrayAllBands;

	      int k =0; 	
	
	for (int bn=0; bn<bns; bn++) // each band
	{
		CString& Band = m_Bands[bn];
//        m_DxccInfo[bn].RemoveAll();
		if(!(strcmp(Band,"160m"))) k=0;
		if(!(strcmp(Band,"80m"))) k=1;	
		if(!(strcmp(Band,"40m"))) k=2;
		if(!(strcmp(Band,"20m"))) k=3;
		if(!(strcmp(Band,"15m"))) k=4;
		if(!(strcmp(Band,"10m"))) k=5;
		m_DxccInfo[k].RemoveAll();
		m_RusObl[k].RemoveAll();

		int iMyCountries=0, iMyConts=0, iDxs=0, iDxccs=0, iDoms=0,/* iConts=0,*/
			iPoints=0 , iQso_Band=0 , iQSO_PS = 0 , iQSO_PM = 0 , iQSO_PO = 0;;

		CStringArray DxccArray, DomArray; /*ContArray*/;

		for (int qn=0; qn<qsos; qn++) // each QSO
		{
			CInfo& Info = m_InfoList[qn];

			if (Info.m_sBandName==Band && !Info.m_sCall.IsEmpty()) // this band?
			{

				// QSOs
				iQso_Band++;

                if (!(strcmp(Info.m_sModeName,"BPSK31") ))
			        	iQSO_PS++;
				if (!(strcmp(Info.m_sModeName,"BPSK63") ))
			        	iQSO_PM++;
				if (!(strcmp(Info.m_sModeName,"BPSK125") ))
			        	iQSO_PO++;

                if (m_sMyCountry == Info.m_sDxccCountry) // my country
					{
						
						iMyCountries++;
					}
					else
						{
							if (m_sMyCont == Info.m_sCont) // my cont

							iMyConts++;

								else	// other cont
						
								iDxs++;

						}

			

				// Calculate number of domains

				if (!Info.m_sDomain.IsEmpty())
				{
					int domn = DomArray.GetSize();
					for (i=0; i<domn; i++)
					{
						if (DomArray[i] == Info.m_sDomain) 
							break; // already exists
					}
					if (i==domn)
					{
						DomArray.Add(Info.m_sDomain); // Add
						m_RusObl[k].Add(Info.m_sDomain);
						iDoms++;

							
					}
				}


				// Calculate number of DXCC countries
				{
					int dxccn = DxccArray.GetSize();
					for (int i=0; i<dxccn; i++)
					{
						if (DxccArray[i] == Info.m_sDxccCountry) 
							break; // already exists
					}
					if (i==dxccn)
					{
						DxccArray.Add(Info.m_sDxccCountry); // Add
						iDxccs++;
						m_DxccInfo[k].Add(Info.m_sDxccCountry);
					}
				}


			}
		}

		if((Band == "160m") || (Band == "80m") || ( Band == "40m"))
			iPoints = iMyCountries*2 + iMyConts*6 + iDxs*10 ;
		else 
			iPoints = iMyCountries + iMyConts*3 + iDxs*5 ; 

		// Band statistics

		CString sBandStats;
		sBandStats.Format(
			"%s\t %i\t %i\t %i\t %i\t %i\t %i\t %i\r\n",
			Band,iQso_Band,iPoints, iDxccs, iDoms,iQSO_PS,iQSO_PM,iQSO_PO 
			);

		result += sBandStats;

		iMyCountriesTotal += iMyCountries;
		iMyContsTotal += iMyConts;
		iDxsTotal += iDxs;
		iDxccsTotal += iDxccs;
		iDomsTotal += iDoms;
		iPointsTotal += iPoints;
		iQSO_PS_Total += iQSO_PS;
		iQSO_PM_Total += iQSO_PM;
		iQSO_PO_Total += iQSO_PO;
	
	}

	// Total statistics

	CString sAllStats;
	sAllStats.Format(
		"Total\t %i\t %i\t %i\t %i\t %i\t %i\t %i\r\n",
		qsos,iPointsTotal,iDxccsTotal,iDomsTotal,iQSO_PS_Total,iQSO_PM_Total,iQSO_PO_Total
		);

	result += sAllStats;

	int score = iPointsTotal*(iDxccsTotal+iDomsTotal);
	*iScore = gblScore = score;
    CString s;
	s.Format("%i", score);
    WritePrivateProfileString("Settings", "Claimed", s, filename);
	

	CString sClaimed;
	sClaimed.Format( "\r\nScore: %i*(%i+%i) = %i\r\nCreated by R3BB 2013.",
		iPointsTotal, iDxccsTotal, iDomsTotal,score);


	result += sClaimed;
	if (m_bGeneratingLog)
	{           


		for (int qn=0; qn<qsos; qn++) // each QSO
		{
			CInfo& Info = m_InfoList[qn];
			CString sMode = "??";
			if (!(strcmp(Info.m_sModeName,"BPSK31") ))
			        	sMode = "PS";
		    else if (!(strcmp(Info.m_sModeName,"BPSK63") && strcmp(Info.m_sModeName,"BPSK62")))
				             sMode = "PM";
				 else if (!(strcmp(Info.m_sModeName,"BPSK125")))
				                sMode = "PO";
				
			LogWriter.AddQso(Info.m_sCall,Info.m_kHz, sMode, &Info.m_DT, Info.m_sRstS, Info.m_sExchgS, Info.m_sRstR, Info.m_sExchgR); 
		}
		CString sMessage = LogWriter.ProduceLog();
		  MessageBox(AfxGetMainWnd()->m_hWnd, sMessage, "Output", MB_OK|MB_ICONINFORMATION ); 

		*iScore = -1;
	}	
	


	return result;
}

//********************************************************************//
//                 QSO         // 
//                    MixW .        //
//                            //
//********************************************************************//
_declspec(dllexport) int CheckCallFunc0 (
		const char* sCall,			
									
		unsigned int uiFqRx,		
		unsigned int uiFqTx,		
		const char* sMode,			

		const char* sName,			
		const char* sQTH,
		
		const char* sInfo,			
		const char* sQslTo,			
		const char* sDom,			
		const char* sCounty,		
		const char* sIota,			
		const char* sWWLoc,			

		const char* sPrefix,		
		const char* sDxccPrefix,		
		int iCq,					
		int iItu,					
		int iTz,					
		double iLat,				
		double iLon,				
		const char* sCountry,		
		const char* sCont,			
		const char* sContinent,
		const char* DomainInfo,
		const char* DomainId,

		const char* sBandRx,		
		const char* sBandTx,

		char* pSuggestedSerial,
		char* pCheckCalltext
		)
{
	SYSTEMTIME st;
	//BOOL bNeedMult = 1;
	CInfo NewInfo;
	CInfo Info;
	int k=0;
	int r=0;
	int l=0;
	int m=0;
	CString Suggest;
	CString out100;
	char str1[4];
	int  iRet;
 

    if(m_pDXCC)		m_pDXCC->SetTimer(1442,332,0);


	int qsos = m_InfoList.GetSize();


	for (int qn=0; qn<qsos; qn++) // each QSO
	 {
		Info = m_InfoList[qn];  
	 }
    if(Info.m_sBandName == sBandRx) Band10 = TRUE;
     else Band10 = FALSE;
	
	iRet = CC_NEW_MULT;

	// find previous QSO with this call

	NewInfo.m_sCall = sCall;
	NewInfo.m_sBandName = sBandRx;
	NewInfo.m_sModeName = sMode;
    NewInfo.m_sCont = sCont;
    NewInfo.m_sDxccCountry = sDxccPrefix;
    NewInfo.m_sDomain = DomainId;

	qsos = m_InfoList.GetSize();
	for (qn=0; qn<qsos; qn++)
	{
		if (m_InfoList[qn].m_sCall==NewInfo.m_sCall)
			
		{ 
			if(m_InfoList[qn].m_sBandName == NewInfo.m_sBandName)
			{
				if(m_InfoList[qn].m_sModeName == NewInfo.m_sModeName)
				{
						break; //QSO BEFORE
				}
				else				
					k = COleDateTime::GetCurrentTime().GetMinute();
			}
			else
				k = COleDateTime::GetCurrentTime().GetMinute();		 
			r=(m_InfoList[qn].m_DT).GetHour();
			m=(m_InfoList[qn].m_DT).GetMinute();
			GetSystemTime(&st);
			l=st.wHour;
		}
		
	}

// Check for before QSO
	if (qn!=qsos)
	{
		iRet = CC_QSOB4;
		return iRet;
	}
	 

		for (qn=0; qn<qsos; qn++)
		{

		   if(m_InfoList[qn].m_sBandName == NewInfo.m_sBandName)
		   {
//			  if(m_InfoList[qn].m_sModeName == NewInfo.m_sModeName)       ,    
//			  {
                   if(m_InfoList[qn].m_sDxccCountry == NewInfo.m_sDxccCountry) 
			        {
				      iRet = CC_NEW_QSO;
				      break;
			        }
//			  }
		    }
		}
		


//     Check for mult Russian Area
      if((!(strcmp(NewInfo.m_sDxccCountry,"UA")))   || (!(strcmp(NewInfo.m_sDxccCountry,"UA2"))) || (!(strcmp(NewInfo.m_sDxccCountry,"UA9"))))

	   {
		   iRet = CC_NEW_MULT;
	    for (qn=0; qn<qsos; qn++)
		{

		   if(m_InfoList[qn].m_sBandName == NewInfo.m_sBandName)
		   {
//			  if(m_InfoList[qn].m_sModeName == NewInfo.m_sModeName)   
//			  {
                   if(m_InfoList[qn].m_sDomain == NewInfo.m_sDomain) 
			        {
				      iRet = CC_NEW_QSO;
				      break;
			        }
//			  }
		    } 
		}
		
	   }


 if(k!=0)
    {
		
	    if((l-r)<0) l=l+24;
		if((l-r)<2) 
		
		{
			if((k-m)<0) k=60+k;
			if((k-m)<4) 
				{
				k=3-(k-m);
			    ultoa(k,str1,10);
    		    if(Band10 == TRUE)
			    {
			         iRet = CC_QSOB4;
			          if(RU==1) 
				       {   
					     switch (k)
					        {
					          case 0:
					           {
						          out100 = "QSO c " ; 
						          out100 = out100 + sCall + "    !!!     !!!"; 
					              break ;
					            }
					          case 1:
						       {
						         out100 = "QSO c " ; 
						         out100 = out100 + sCall + "    !!!  " + str1 + "  !!!"; 
						         break ;
						        }
								
					        }
					           if((k>4) && (k<11))  
					           {
						         out100 = "QSO c " ; 
						         out100 = out100 + sCall + "    !!!  " + str1 + "  !!!";
					            }
				               if((k>1) && (k<5)) 
					            {
						          out100 = "QSO c " ; 
						          out100 = out100 + sCall + "    !!!  " + str1 + "  !!!";
					            }
					              strcpy(pCheckCalltext,out100);
				        }
				        else 
				            {
				            	out100="QSO WITH "; out100 = out100 + sCall + " WHILE IT IS IMPOSSIBLE !!! WAIT " + str1 + "MINTUTES !!!";
					            strcpy(pCheckCalltext,out100);
				            }  
     		    }  
			}
		}

	}
        if((!(strcmp(NewInfo.m_sDxccCountry,"UA")))   || (!(strcmp(NewInfo.m_sDxccCountry,"UA2"))) || (!(strcmp(NewInfo.m_sDxccCountry,"UA9"))))
		{
			Suggest = CheckOblast(sCall);
		}

	if (pSuggestedSerial)
	{
	 if(mast) strcpy(pSuggestedSerial,Suggest);
	}		
	if(m_pObl) m_pObl->SetTimer(1500,300,0);

	return iRet;

}
//********************************************************************//
//               MixW      //
//********************************************************************//
_declspec(dllexport) int StatsGetExchgCount0(const char* sCall, const char* sCountryPfx, const char* sCont)
{

	return 1; // always 1
}
//********************************************************************//
//                                              //
//********************************************************************//

_declspec(dllexport) int StatsIsValidExchg0(const char* sExchg, const char* sCall, const char* sCountryPfx, const char* sCont, int iITU, int iWAS, int idx)
{
	const char* domainid;
	char i;
	int len = strlen(sExchg);

	char* p = (char*)sExchg;
	if (idx == 0)
	{
	if(!(strcmp(sExchg ,"599"))) return 0;
	if((len==3) || (len ==4))
	{	
		while (*p)
		{
			if (!isdigit(*p))
				return FALSE;
			p++;
		}

		  return 1;
	}


	else
	
      
 
      if((!(strcmp(sCountryPfx,"UA"))) || (!(strcmp(sCountryPfx,"UA2"))) || (!(strcmp(sCountryPfx,"UA9"))))
		if(len == 2)  
		  if (CheckDomain(sExchg))
		  {
			  len = strlen(sCall);
              for (i=0;i<len;i++)
			   if ((sCall[i]&0x2F) == 0x2F) return 1; //If in CALL found "/" hwataem 4to prinjali
			  
		      domainid = CheckOblast(sCall );
		      if(!(strcmp(sExchg,domainid))) return 1;
		  }
                 

	}
    
	
	return 0;
}

//********************************************************************//
//                         //
//********************************************************************//

_declspec(dllexport) const char* RunCommand0(int iCommand, const char* sParam)
{	
	CString s = sParam;
	if (s=="SHOWINFO")
	{
		ShowInfoWindow();
		return gblNull;
	}
	if (s=="HIDEINFO")
	{
		HideInfoWindow();
		return gblNull;
	}

	return gblNull;
}
