// baud.cpp : implementation file
//

#include "stdafx.h"
#include "cabrillo.h"
#include "baud.h"
#include "DXCC.h"
#include "oblast.h"
#include "mixw2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//****************************************************************************//
//     BPSK
//****************************************************************************//
/////////////////////////////////////////////////////////////////////////////
// baud dialog
//   
extern IMixW2 mixw;
extern CLSID clsid;
extern IUnknown *pUnk;
extern IDispatch *pDisp;
extern HRESULT hr;

//   Rus Obl
extern oblast *m_pObl;
//  DXCC
extern DXCC *m_pDXCC;

RECT rRect;
int x;
int y;

extern void WritePrivateProfileInt(CString Section, CString Key, int iValue, CString IniFilename);
extern	CString IniSection;// = "Settings";
extern    CString IniFilename;// = "Plugins\\EPCRU.ini";
#define MAX_BUF 10000
extern	char buf[MAX_BUF+1];

	char RusObl=0;
	char DXcc=0;

baud::~baud()
{


}

baud::baud(CWnd* pParent /*=NULL*/)
	: CDialog(baud::IDD, pParent)
{
	//{{AFX_DATA_INIT(baud)   
	m_pObl = NULL;
	m_pDXCC= NULL;
	m_sView_Rus = FALSE;
	m_sView_DXCC = FALSE;
	//}}AFX_DATA_INIT
}


void baud::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(baud)
	DDX_Control(pDX, IDC_PSK63, m_psk63);
	DDX_Control(pDX, IDC_PSK125, m_psk125);
	DDX_Control(pDX, IDC_PSK31, m_psk);
	DDX_Check(pDX, IDC_View_Rus, m_sView_Rus);
	DDX_Check(pDX, IDC_DXCC, m_sView_DXCC);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(baud, CDialog)
	//{{AFX_MSG_MAP(baud)
	ON_BN_CLICKED(IDC_PSK31, OnPsk31)
	ON_BN_CLICKED(IDC_PSK63, OnPsk63)
	ON_BN_CLICKED(IDC_PSK125, OnPsk125)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_View_Rus, OnViewRus)
	ON_BN_CLICKED(IDC_DXCC, OnDxcc)
	ON_WM_TIMER()
	ON_WM_SETCURSOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// baud message handlers

//********************************************************************//
//                  BPSK             //
//********************************************************************//
BOOL baud::OnInitDialog() 
{
	CDialog::OnInitDialog();

    
	// TODO: Add extra initialization here
    GetPrivateProfileString(IniSection, "baud_x", "", buf, MAX_BUF, IniFilename);
	x = atoi(buf);
	GetPrivateProfileString(IniSection, "baud_y", "", buf, MAX_BUF, IniFilename);
	y = atoi(buf);
    if(x ==0) x=10;
    if(y==0) y=10;

	SetWindowPos(NULL,x,y, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	SetWindowPos(&wndTopMost,0, 0, 0, 0,
			SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);

	my_color.CreateSolidBrush(RGB(255,250,198));  //     
      	CWinThread* p = AfxGetThread();
			HICON newIcon= AfxGetApp()->LoadIcon(IDI_ICON1);
			(this)->SetIcon(newIcon,TRUE);
    SetTimer(1444,300,0);

		

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//********************************************************************//
//                       BPSK31                     //
//********************************************************************//

void baud::OnPsk31() 
{
	// TODO: Add your control notification handler code here

   
//    
  ((*(COleDispatchDriver*)(&mixw))).m_lpDispatch = pDisp;//Init object


	mixw.ExecuteMacros("<MODE:BPSK31>");
          	
}

//********************************************************************//
//                       BPSK63                     //
//********************************************************************//


void baud::OnPsk63() 
{
	// TODO: Add your control notification handler code here 
   
//    
  ((*(COleDispatchDriver*)(&mixw))).m_lpDispatch = pDisp;//Init object

    mixw.ExecuteMacros("<MODE:BPSK31>");
	mixw.ExecuteMacros("<BAUDRATE:63>");
	
}

//********************************************************************//
//                       BPSK125                     //
//********************************************************************//
void baud::OnPsk125() 
{
	// TODO: Add your control notification handler code here

   
//    
  ((*(COleDispatchDriver*)(&mixw))).m_lpDispatch = pDisp;//Init object

    mixw.ExecuteMacros("<MODE:BPSK31>");
	mixw.ExecuteMacros("<BAUDRATE:125>");
		
}

//********************************************************************//
//                                       //
//********************************************************************//

HBRUSH baud::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here


		pDC->SetTextColor(0);
		pDC->SetBkColor(RGB(255,250,198));
		return my_color;
	return hbr;
}

//********************************************************************//
//             /          //
//********************************************************************//
void baud::OnViewRus() 
{

	if(!m_pObl)
	{
		m_pObl = new oblast();
		m_pObl->Create(IDD_DIALOG3);
		m_pObl->ShowWindow(SW_SHOW);
		WritePrivateProfileString(IniSection, "RusObl", "1",  IniFilename);

	}
	else
	{
		m_pObl->KillTimer(1500);
		m_pObl->SendMessage(WM_CLOSE);
//		delete m_pObl;

		m_pObl = NULL;
						WritePrivateProfileString(IniSection, "RusObl", "0",  IniFilename);
	}
	// TODO: Add your control notification handler code here
	
}


//********************************************************************//
//             /    DXCC           //
//********************************************************************//
void baud::OnDxcc() 
{

	if(!m_pDXCC)
	{
		m_pDXCC = new DXCC();
		m_pDXCC->Create(IDD_DIALOG5);
		m_pDXCC->ShowWindow(SW_SHOW);
				WritePrivateProfileString(IniSection, "DXCC", "1",  IniFilename);
	}
	else
	{
		m_pDXCC->KillTimer(1442);
		m_pDXCC->SendMessage(WM_CLOSE);
//		delete m_pDXCC;
		m_pDXCC = NULL;
		WritePrivateProfileString(IniSection, "DXCC", "0",  IniFilename);

	}



	// TODO: Add your control notification handler code here
	
}


//********************************************************************//
//               //
//********************************************************************//
void baud::OnTimer(UINT nIDEvent) 
{
		CDialog::OnTimer(nIDEvent);
	// TODO: Add your message handler code here and/or call default

		KillTimer(1444);
		
	//    

	CLSIDFromProgID(L"MixW2.Application", &clsid);
	::CoInitialize(NULL);
 
    hr =GetActiveObject(clsid,NULL , (IUnknown**)&pUnk); 
	  if(SUCCEEDED(hr)) 
	   {
	     hr = pUnk->QueryInterface(IID_IDispatch, (void **)&pDisp);

	  }

	//Release the no-longer-needed IUnknown...
	if (pUnk) 
	 pUnk->Release();

	//  


//    DXCC

	GetPrivateProfileString(IniSection, "RusObl", "", buf, MAX_BUF, IniFilename);
		RusObl = atoi(buf);
		if(RusObl) 
		{


				m_pObl = new oblast();
				m_pObl->Create(IDD_DIALOG3);
								m_sView_Rus = TRUE;
								UpdateData(false);
				m_pObl->ShowWindow(SW_SHOW);

		}

	

		GetPrivateProfileString(IniSection, "DXCC", "", buf, MAX_BUF, IniFilename);
		DXcc = atoi(buf);
		if(DXcc) 
		{


				m_pDXCC = new DXCC();
				m_pDXCC->Create(IDD_DIALOG5);
					m_sView_DXCC = TRUE;
								UpdateData(false);
				m_pDXCC->ShowWindow(SW_SHOW);

		}
	
	

}


//********************************************************************//
//                     //
//********************************************************************//

BOOL baud::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// TODO: Add your message handler code here and/or call default
	char buf[10];
	GetWindowRect(&rRect);
    int x1 = rRect.left;
	int y1 = rRect.top;
	
	if(x1 != x) 
	{
		
		x = x1;
	    itoa(x,buf,10);
		WritePrivateProfileString(IniSection, "baud_x", buf,  IniFilename);

	}
	if(y1 != y) 
	{
		y = y1;
		itoa(y,buf,10);
		WritePrivateProfileString(IniSection, "baud_y", buf,  IniFilename);

	}	
	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}
